【LeetCode】每日一题 2024_9_27 每种字符至少取 K 个(双指针)

前言

每天和你一起刷 LeetCode 每日一题~

LeetCode 启动!

题目:每种字符至少取 K 个

代码与解题思路

go 复制代码
func takeCharacters(s string, k int) int {
    // 核心思路:
    // 题目要求字符串 s 中,每种字符都取至少 k 个
    // 而且可以从头取,也可以从尾巴取,找出取的时间最短的方法
    // 不妨试着先从尾巴开始取,直到达成题目的要求(达不成就直接返回 -1 即可)
    // 然后再从头开始取,用滑动窗口的思想,找出:"需要的 最少 分钟数"(最优情况)

    n := len(s)
    // 由字符 'a'、'b'、'c' 组成的字符串 s,所以 cnt 只用记录者三种字符即可
    cnt, l := [3]int{}, n
    for cnt[0] < k || cnt[1] < k || cnt[2] < k {
        if l == 0 { // 达不成要求,直接返回 -1
            return -1
        }
        l--
        cnt[s[l]-'a']++
    }
    
    ans := n-l // 目前需要的分钟数
    // 滑动窗口,或者说双指针
    for r := range s { // 维护 cnt 数组中这三个字符的数量,更新子串的最小值
        cnt[s[r]-'a']++
        for l < n && cnt[s[l]-'a'] > k {
            cnt[s[l]-'a']--
            l++
        }
        ans = min(ans, n-l + r+1) // 头的长度 + 尾的长度
    }
    return ans
}

今天这道题目比较难想,是力扣之前的一道周赛题,我曾经做过,所以才有思路,如果第一次做大概也做不太出来

核心思路如注释

这道题的难点就在于,题目要求子串的最小值,但是可以从字符串的头开始,也可以从尾开始,两头加在一起的最小值,怎么样才能判断出来呢?

下次遇到这种类型的题目就知道该怎么操作了,既然头尾都可以,那就先全用尾巴的子串,然后再起一个循环,遍历头部的子串来维护整体长度的最小值


题外话

最近在刷字节青训营给的题目,据说这些题目都是字节曾经出过的笔试面试的真题,到时候我做出一定成果了就来分享一下~

视频实况

【【LeetCode】每日一题 2024_9_27 每种字符至少取 K 个(双指针)】

每天进步一点点

可以和我刷一辈子的每日一题吗?

一题一题,积累起来就是一辈子。

相关推荐
程序员yu15 分钟前
会编网络:别被入门教程骗了,Python实用能力不在语法本身
开发语言·python·学习·算法
解决小子42 分钟前
2026年中国就业情况报告
ai·职场和发展·创业创新·业界资讯·就业
Allen_LVyingbo1 小时前
信息化部门在AI时代的编程转移路径分析(上)
人工智能·python·算法·健康医疗·数据库开发·时序数据库·数据库架构
七牛云行业应用1 小时前
Jev 报 401 / api_key_required 怎么解决:TypeSafe AI 官方错误码表与排查步骤
算法·github
晴天的雨.9921 小时前
【C++算法】三数之和
开发语言·c++·算法
多多爱学习2 小时前
括号有几层?得看还有多少个左括号没闭合
c语言·c++·算法·面试
续写烂尾3 小时前
MK SD NAND(贴片式TF卡)替代Nor Flash:1Gb容量与256Mb Nor
算法·microsoft
u0111026753 小时前
图片预览越来越占内存聊聊 URL.createObjectURL 的释放时机
图像处理·深度学习·算法·ai作画
Zane19943 小时前
同样是遍历图,为什么BFS能保证找到最短路径,DFS却不行
算法
无限码力3 小时前
2026华为OD机试真题 新系统 9月27日【坚果巧克力】
算法·华为od·华为od机考·华为od机试真题·华为od机试·华为od机考真题题解·华为社招笔试真题